100 rem $$asmb=win1_uti_wrp_DocWrap_bin,0,10
102 rem $$stak=4096
104 rem $$buff=4096
106 rem $$chan=4
108 :
110 ext_fn 'VALID%', 'DETAB$'
112 :
114 rem + ************************************************************************ +
116 rem *<                                DocWrap                                 >*
118 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
120 rem *              Simple script to wrap lines in a text document              *
122 rem *                                                                          *
124 rem * Lines that are longer than average, eg if edited by TextPad without      *
126 rem * breaks get wrapped to the line length given.                             *
128 rem *                                                                          *
130 rem * This program could be improved by adding a few markup clues in the       *
132 rem * text.                                                                    *
134 rem *                                                                          *
136 rem *      <filename>            a file name on its own => in = out, ll = 75   *
138 rem *   /I <input file name>                                                   *
140 rem *   /O <output file name>                                                  *
142 rem *   /L <line length in char>                                               *
144 rem *                                                                          *
146 rem * Dependencies: VALID%, DETAB$                                             *
148 rem + ------------------------------------------------------------------------ +
150 rem * V0.01, pjw, 2022 Jun 30                                                  *
152 rem + ************************************************************************ +
154 :
156 quote$ = '"' & "'":    rem Quote charcters
158 ll%    = ' 75 Default line length': rem Alter this in the binary!
160 :
162 er = GetCMD(CMD$): if er < 0: quit er
164 :
166 ci = fop_in(ifn$): if ci < 0: quit ci
168 co = fop_over(ofn$): if co < 0: close#ci: quit co
170 :
172 ml%  = 0
174 rep lp
176  if eof(#ci): exit lp
178  input#ci; l$: l% = len(l$)
180  if l% > ml%: ml% = l%
182  if l% <= ll% then
184   bput#co; l$, 10
186   next lp
188  endif
190  h% = Wrap%(ll%, '', l$)
192  bput#co; l$, 10
194 endrep lp
196 close
198 if tmp then
200  copy_o ofn$ to ifn$
202  delete ofn$
204 endif
206 :
208 beep 2000, 2
210 quit ml%
212 :
214 :
216 rem + ------------------------------------------------------------------------ +
218 rem |<                                 Wrap%                                  >|
220 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
222 rem |             Reformat a string to conform to width restraint              |
224 rem |       and return the number of lines it will take to display it          |
226 rem |                                                                          |
228 rem | A complete re-think on Wrap. (Probably not yet perfect..)                |
230 rem |                                                                          |
232 rem | Given                                                                    |
234 rem |   wid%   = field width in char                                           |
236 rem |   split$ = split character - an optional alternative character to LF     |
238 rem |   r.txt$ = the text to be wrapped. (Note this text is altered by Wrap!)  |
240 rem |                                                                          |
242 rem | the Wrap function returns the number of max width-sized segments of the  |
244 rem | reformatted string r.txt$. The calling parameter of r.txt$ can be        |
246 rem | printed to screen directly, or easily parsed for justification.          |
248 rem |                                                                          |
250 rem |If split$ is given as "" then the split character reverts to LF/chr$(10)  |
252 rem |                                                                          |
254 rem | Maybe do something more with hyphens later..                             |
256 rem + ------------------------------------------------------------------------ +
258 rem | V0.04, pjw, 2017 Feb/Jun, Complete re-write                              |
260 rem | V0.06, pjw, 2021 Apr 12, Complete re-write (again!)                      |
262 rem + ------------------------------------------------------------------------ +
264 :
266 DEFine FuNction Wrap%(wid%, split$, r.txt$)
268 loc wl, i%, c%, h%, p%, s%, e%, lf%
270 :
272 lf% = code(split$): if lf% = 0: lf% = 10
274 h% = 1: e% = len(r.txt$)
276 :
278 i% = 0: p% = 0: s% = 0
280 rep wl
282  i% = i% + 1: if i% > e%: exit wl
284  c% = code(r.txt$(i%))
286  sel on c%
288   = 10:  h% = h% + 1: p% = 0: s% = 0: next wl
290   = lf%: r.txt$(i%) = chr$(10)
292          h% = h% + 1: p% = 0: s% = 0: next wl
294   = 32:  s% = i%
296  endsel
298  :
300  p% = p% + 1
302  if p% = wid% then
304   if s% = 0 then
306    r.txt$ = r.txt$(1 to i% - 1) & '-' & chr$(10) & r.txt$(i% to e%)
308    e% = e% + 2
310   else
312    if (i% + 1) > e%: exit wl
314    if code(r.txt$(i% + 1)) = 32 then
316     r.txt$(i% + 1) = chr$(10)
318    else
320     r.txt$(s%) = chr$(10)
322     h% = h% + 1: i% = s%
324    endif
326    s% = 0
328   endif
330   p% = 0
332  endif
334 endrep wl
336 return h%
338 end def Wrap%
340 :
342 :
344 rem + ------------------------------------------------------------------------ +
346 rem |<                                 GetCMD                                 >|
348 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
350 rem | Parse Command line                                                       |
352 rem |  This is QIOT's standard command line parser. Fill in the details as     |
354 rem | required.                                                                |
356 rem | Dependencies:                                                            |
358 rem |  Requires VALID%, DETAB$                                                 |
360 rem |  fn GetEnt$                                                              |
362 rem | NB: Long integers should be supplied as 32bit hex for clarity and        |
364 rem | consistency                                                              |
366 rem + ------------------------------------------------------------------------ +
368 rem |  V0.01, pjw, November 29th 2016                                          |
370 rem + ------------------------------------------------------------------------ +
372 rem |                              GetCMD DocWrap                              |
374 rem |                                                                          |
376 rem | If a file name ending in txt is found in the stuffer buffer, and no valid|
378 rem | file name is found on the command line then the file name from the       |
380 rem | stuffer buffer is used and the program behaves as for a single           |
382 rem | input file name.                                                         |
384 rem |                                                                          |
386 rem |      <filename>            a file name on its own => in = out, ll = 75   |
388 rem |   /I <input file name>     if only input finame is give, then in = out   |
390 rem |   /O <output file name>                                                  |
392 rem |   /L <line length in char> if no ll is given then default is ll = 75     |
394 rem |                                                                          |
396 rem + ------------------------------------------------------------------------ +
398 rem |  V0.01, pjw, 2022 Jun 30, for DocWrap                                    |
400 rem |  V0.02, pjw, 2024 Feb 06, Added stuffer buffer functionality             |
402 rem + ------------------------------------------------------------------------ +
404 :
406 def fn GetCMD(cl$)
408 loc l%, t$
410 :
412 ofn$ = 'ram1_' & hex$(date, 32) & '_tmp'
414 tmp  = 1
416 ifn$ = ''
418 :
420 l% = len(cl$)
422 if l% < 6 then
424  ifn$ = hot_getstuff$: l% = len(ifn$)
426  if l% > 5 then
428   if not (ifn$(l% - 2 to l%) == 'txt'): l% = 0
430  else
432   l% = 0
434  endif
436 else
438  if not '/' instr cl$ then
440   ifn$ = cl$: l% = len(ifn$)
442   if l% < 6: l% = 0
444  else
446   l% = 0
448  endif
450 endif
452 :
454 if l%: ret 0:   rem We have a filename. We're done here
456 :
458 ifn$ = Getent$("I")
460 if len(ifn$) < 6: ret -7
462 :
464 t$ = Getent$("O")
466 if len(t$) then
468  if len(t$) < 6: ret -12
470  ofn$ = t$: tmp = 0
472 endif
474 :
476 t$ = Getent$("L")
478 if len(t$) then
480  if not valid%(3, t$): ret -15
482  ll% = t$
484 endif
486 ret 0
488 enddef GetCmd
490 :
492 def fn Getent$(k$)
494 loc p%, t$
496 rem Caller's cl$
498 rem Given the character get the entry
500 rem /C [<spaces>] ["|'] <entry> ["|'] <space> | / | <eol>
502 rem Doesnt check if quotes match. Doesnt accept literal /
504 :
506 p% = '/' & k$ instr cl$
508 if p% = 0: ret ''
510 t$ = DETAB$(cl$(p% + 2 to len(cl$)))
512 p% = '/' instr t$
514 if p% > 0: t$ = t$(1 to p%): else: p% = len(t$)
516 for p% = len(t$) to 1 step -1
518  if not t$(p%) instr ' /': exit p%
520 endfor p%
522 :
524 t$ = t$(1 to p%)
526 if len(t$) > 1 then
528  p% = t$(1) instr quote$
530  if p% then
532   if (t$(len(t$)) instr quote$) = p% then
534    t$ = t$(2 to len(t$) - 1)
536 endif: endif: endif
538 ret t$
540 enddef Getent$
542 :
544 :
